#Features

- Retrieving Events 
    - From various data sources supporting multiple message formats
 - Mapping Events
    - Mapping events with various data formats to Stream for processing
    - Mapping streams to multiple data formats for publishing
 - Processing Streams
    - Filter 
        - Filtering stream based on conditions
    - Window
        - Support for sliding and batch (tumbling) and many other type of windows  
    - Aggregation 
        - Supporting `Avg`, `Sum`, `Min`, `Max`, etc
        - For long running aggregations and aggregation over windows 
        - Ability to perform aggregate processing with `Group by` and filter aggregated data with `Having` conditions
    - Incremental Aggregation
        - Support for processing and retrieving long running Aggregation
        - Supports data processing in seconds, minutes, hours, days, months, and years granularity
    - Table and Stores
        - For storing events for future processing and retrieving them on demand
        - Supporting storage in in-memory, RDBMs, Solr, mongoDb, etc 
    - Join
        - Joining two streams, two windows based on conditions 
        - Joining stream/window with table or incremental aggregation based on conditions  
        - Supports inner joins, and left, right & full outer joins
    - Pattern 
        - Identifies event occurrence patterns among streams over time
        - Identify non occurrence of events
        - Supports repetitive matches of event pattern occurrences with logical conditions and time bound
    - Sequence processing
        - Identifies continuous sequence of events from streams
        - Supports zero to many, one to many, and zero to one event matching conditions
    - Partitions
        - Grouping queries and based on keywords or value ranges for isolated parallel processing
    - Scripting 
        - Support writing scripts like JavaScript, Scala and R within Siddhi Queries
    - Process Based on event time
        - Whole execution driven by the event time    
 - Publishing Events 
    - To various data sources with various message formats
    - Supporting load balancing and failover data publishing 
 - Error handling
    - Support errors and exceptions through error streams
    - Automatic backoff retries to external data stores, sources and sinks. 
 - Parallel processing 
    - Support parallel processing through asynchronous multithreading at streams  
 - Snapshot and restore
    - Support for periodic state persistence and restore capabilities to allow state restore during failures